/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplateMessageComponentParametersInnerDateTime type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplateMessageComponentParametersInnerDateTime{}

// WhatsAppTemplateMessageComponentParametersInnerDateTime struct for WhatsAppTemplateMessageComponentParametersInnerDateTime
type WhatsAppTemplateMessageComponentParametersInnerDateTime struct {
	FallbackValue *string `json:"fallback_value,omitempty"`
	Timestamp *string `json:"timestamp,omitempty"`
	DayOfWeek *string `json:"day_of_week,omitempty"`
	DayOfMonth *string `json:"day_of_month,omitempty"`
	Year *string `json:"year,omitempty"`
	Month *string `json:"month,omitempty"`
	Hour *string `json:"hour,omitempty"`
	Minute *string `json:"minute,omitempty"`
}

// NewWhatsAppTemplateMessageComponentParametersInnerDateTime instantiates a new WhatsAppTemplateMessageComponentParametersInnerDateTime object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplateMessageComponentParametersInnerDateTime() *WhatsAppTemplateMessageComponentParametersInnerDateTime {
	this := WhatsAppTemplateMessageComponentParametersInnerDateTime{}
	return &this
}

// NewWhatsAppTemplateMessageComponentParametersInnerDateTimeWithDefaults instantiates a new WhatsAppTemplateMessageComponentParametersInnerDateTime object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateMessageComponentParametersInnerDateTimeWithDefaults() *WhatsAppTemplateMessageComponentParametersInnerDateTime {
	this := WhatsAppTemplateMessageComponentParametersInnerDateTime{}
	return &this
}

// GetFallbackValue returns the FallbackValue field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetFallbackValue() string {
	if o == nil || IsNil(o.FallbackValue) {
		var ret string
		return ret
	}
	return *o.FallbackValue
}

// GetFallbackValueOk returns a tuple with the FallbackValue field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetFallbackValueOk() (*string, bool) {
	if o == nil || IsNil(o.FallbackValue) {
		return nil, false
	}
	return o.FallbackValue, true
}

// HasFallbackValue returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) HasFallbackValue() bool {
	if o != nil && !IsNil(o.FallbackValue) {
		return true
	}

	return false
}

// SetFallbackValue gets a reference to the given string and assigns it to the FallbackValue field.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) SetFallbackValue(v string) {
	o.FallbackValue = &v
}

// GetTimestamp returns the Timestamp field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetTimestamp() string {
	if o == nil || IsNil(o.Timestamp) {
		var ret string
		return ret
	}
	return *o.Timestamp
}

// GetTimestampOk returns a tuple with the Timestamp field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetTimestampOk() (*string, bool) {
	if o == nil || IsNil(o.Timestamp) {
		return nil, false
	}
	return o.Timestamp, true
}

// HasTimestamp returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) HasTimestamp() bool {
	if o != nil && !IsNil(o.Timestamp) {
		return true
	}

	return false
}

// SetTimestamp gets a reference to the given string and assigns it to the Timestamp field.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) SetTimestamp(v string) {
	o.Timestamp = &v
}

// GetDayOfWeek returns the DayOfWeek field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetDayOfWeek() string {
	if o == nil || IsNil(o.DayOfWeek) {
		var ret string
		return ret
	}
	return *o.DayOfWeek
}

// GetDayOfWeekOk returns a tuple with the DayOfWeek field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetDayOfWeekOk() (*string, bool) {
	if o == nil || IsNil(o.DayOfWeek) {
		return nil, false
	}
	return o.DayOfWeek, true
}

// HasDayOfWeek returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) HasDayOfWeek() bool {
	if o != nil && !IsNil(o.DayOfWeek) {
		return true
	}

	return false
}

// SetDayOfWeek gets a reference to the given string and assigns it to the DayOfWeek field.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) SetDayOfWeek(v string) {
	o.DayOfWeek = &v
}

// GetDayOfMonth returns the DayOfMonth field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetDayOfMonth() string {
	if o == nil || IsNil(o.DayOfMonth) {
		var ret string
		return ret
	}
	return *o.DayOfMonth
}

// GetDayOfMonthOk returns a tuple with the DayOfMonth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetDayOfMonthOk() (*string, bool) {
	if o == nil || IsNil(o.DayOfMonth) {
		return nil, false
	}
	return o.DayOfMonth, true
}

// HasDayOfMonth returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) HasDayOfMonth() bool {
	if o != nil && !IsNil(o.DayOfMonth) {
		return true
	}

	return false
}

// SetDayOfMonth gets a reference to the given string and assigns it to the DayOfMonth field.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) SetDayOfMonth(v string) {
	o.DayOfMonth = &v
}

// GetYear returns the Year field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetYear() string {
	if o == nil || IsNil(o.Year) {
		var ret string
		return ret
	}
	return *o.Year
}

// GetYearOk returns a tuple with the Year field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetYearOk() (*string, bool) {
	if o == nil || IsNil(o.Year) {
		return nil, false
	}
	return o.Year, true
}

// HasYear returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) HasYear() bool {
	if o != nil && !IsNil(o.Year) {
		return true
	}

	return false
}

// SetYear gets a reference to the given string and assigns it to the Year field.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) SetYear(v string) {
	o.Year = &v
}

// GetMonth returns the Month field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetMonth() string {
	if o == nil || IsNil(o.Month) {
		var ret string
		return ret
	}
	return *o.Month
}

// GetMonthOk returns a tuple with the Month field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetMonthOk() (*string, bool) {
	if o == nil || IsNil(o.Month) {
		return nil, false
	}
	return o.Month, true
}

// HasMonth returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) HasMonth() bool {
	if o != nil && !IsNil(o.Month) {
		return true
	}

	return false
}

// SetMonth gets a reference to the given string and assigns it to the Month field.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) SetMonth(v string) {
	o.Month = &v
}

// GetHour returns the Hour field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetHour() string {
	if o == nil || IsNil(o.Hour) {
		var ret string
		return ret
	}
	return *o.Hour
}

// GetHourOk returns a tuple with the Hour field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetHourOk() (*string, bool) {
	if o == nil || IsNil(o.Hour) {
		return nil, false
	}
	return o.Hour, true
}

// HasHour returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) HasHour() bool {
	if o != nil && !IsNil(o.Hour) {
		return true
	}

	return false
}

// SetHour gets a reference to the given string and assigns it to the Hour field.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) SetHour(v string) {
	o.Hour = &v
}

// GetMinute returns the Minute field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetMinute() string {
	if o == nil || IsNil(o.Minute) {
		var ret string
		return ret
	}
	return *o.Minute
}

// GetMinuteOk returns a tuple with the Minute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) GetMinuteOk() (*string, bool) {
	if o == nil || IsNil(o.Minute) {
		return nil, false
	}
	return o.Minute, true
}

// HasMinute returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) HasMinute() bool {
	if o != nil && !IsNil(o.Minute) {
		return true
	}

	return false
}

// SetMinute gets a reference to the given string and assigns it to the Minute field.
func (o *WhatsAppTemplateMessageComponentParametersInnerDateTime) SetMinute(v string) {
	o.Minute = &v
}

func (o WhatsAppTemplateMessageComponentParametersInnerDateTime) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplateMessageComponentParametersInnerDateTime) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.FallbackValue) {
		toSerialize["fallback_value"] = o.FallbackValue
	}
	if !IsNil(o.Timestamp) {
		toSerialize["timestamp"] = o.Timestamp
	}
	if !IsNil(o.DayOfWeek) {
		toSerialize["day_of_week"] = o.DayOfWeek
	}
	if !IsNil(o.DayOfMonth) {
		toSerialize["day_of_month"] = o.DayOfMonth
	}
	if !IsNil(o.Year) {
		toSerialize["year"] = o.Year
	}
	if !IsNil(o.Month) {
		toSerialize["month"] = o.Month
	}
	if !IsNil(o.Hour) {
		toSerialize["hour"] = o.Hour
	}
	if !IsNil(o.Minute) {
		toSerialize["minute"] = o.Minute
	}
	return toSerialize, nil
}

type NullableWhatsAppTemplateMessageComponentParametersInnerDateTime struct {
	value *WhatsAppTemplateMessageComponentParametersInnerDateTime
	isSet bool
}

func (v NullableWhatsAppTemplateMessageComponentParametersInnerDateTime) Get() *WhatsAppTemplateMessageComponentParametersInnerDateTime {
	return v.value
}

func (v *NullableWhatsAppTemplateMessageComponentParametersInnerDateTime) Set(val *WhatsAppTemplateMessageComponentParametersInnerDateTime) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateMessageComponentParametersInnerDateTime) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateMessageComponentParametersInnerDateTime) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateMessageComponentParametersInnerDateTime(val *WhatsAppTemplateMessageComponentParametersInnerDateTime) *NullableWhatsAppTemplateMessageComponentParametersInnerDateTime {
	return &NullableWhatsAppTemplateMessageComponentParametersInnerDateTime{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateMessageComponentParametersInnerDateTime) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateMessageComponentParametersInnerDateTime) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


